/* Unix include files */
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>

/* Some standard definitions */
#define TRUE 1
#define FALSE 0
#define PI 3.1415927

/***** Stuff specific to PGG *****/

/* constants */
#define LINE_LENGTH 80
#define CODE_LENGTH 3
#define ID_LENGTH 2*CODE_LENGTH+2 /* 2 codes, 1 char for reality, 1 for \0 */
#define FNAME_LENGTH 12 /* max. length of .NEW filenames (since DOS
						   compatible (actually is only 11, but might want \0 */
#define NOT_FOUND -1	/* for search functions returning an int */

#define TITLE_CHAR 't'
#define SUMMARY_CHAR 's'
#define AUTHOR_CHAR 'a'
#define DATE_CHAR 'd'
#define FICTION_CHAR 'f'
#define NUMBER_CHAR 'n'
#define XREF_CHAR 'x'
#define INDEX_CHAR 'i'
#define DELIMIT_CHAR 'e'

/****** enumerated types for PGG ******/
enum reality {
	CGD_REAL,
	CGD_SEMI_REAL,
	CGD_UNREAL
};

/* types */
typedef struct XREF_dummy *XREF_ptr;

typedef struct XREF_dummy {
	char xtitle[LINE_LENGTH];	
	char id[ID_LENGTH];
	XREF_ptr next;
} XREF;

typedef struct INDEX_dummy *INDEX_ptr;

typedef struct INDEX_dummy {
	char index_entry[LINE_LENGTH];
	char title[LINE_LENGTH];
	char id[ID_LENGTH];
	INDEX_ptr next;
} INDEX;
	
typedef struct GUIDE_ENTRY_dummy {
    char title[LINE_LENGTH];
    char id[ID_LENGTH];
    char summary[LINE_LENGTH];
    char author[LINE_LENGTH];
    long int date;
    XREF *first_xref;
    INDEX *first_index;
	int article_length;
    char *article;
	long text_start;	/* offset into packed data file where this article
						   starts */
} GUIDE_ENTRY;

