/******************************************************************
**                                                               **
**        Xguide - GUI reader for Project Galactic Guide,        **
**        written for Xwindows using the Motif widget set        **
**                                                               **
**        Author: David Squire          Created: 13/12/93        **
**                                                               **
**        Comments:No where near finished yet!                   **
**                                                               **
**        Modifications:                                         **
**                                                               **
******************************************************************/

/* strip include files - order matters! */
#include "Cguide.h"
#include "Cguide_X.h"
#include "Cguide_std.proto"
#include "Cguide_X.proto" /* must be last!! */

/**********************Globals************************************/

/* X globals */
XtAppContext context;
XmStringCharSet char_set = XmSTRING_DEFAULT_CHARSET;
int squizz_pixmap_created = False;

/* PGG globals */
FILE *entries_file;
int total_entries;
GUIDE_ENTRY **entries;
int total_index_entries;
INDEX *index_entries;
int *toc = NULL; /* table of contents index */
char *months[] = {"0", "January", "February", "March", "April", "May", "June",
"July", "August", "September", "October", "November", "December"};
int display_real, display_semi_real, display_unreal;

/**********************Widgets************************************/
Widget toplevel;
	Widget main_form;
		Widget main_menu_bar;
			Widget file_menu;
				Widget load_item;
				Widget save_item;
				Widget quit_item;
			Widget options_menu;
				Widget reality_item;
					Widget reality_dialog;
						Widget reality_dialog_label1;
						Widget reality_dialog_sep1;
						Widget reality_toggle_rowcol;
							Widget reality_real_toggle;
							Widget reality_semireal_toggle;
							Widget reality_unreal_toggle;
						Widget reality_dialog_sep2;
						Widget reality_button_form;
							Widget reality_dialog_OK_button;
							Widget reality_dialog_CANCEL_button;
			Widget help_menu;
				Widget about_item;
					Widget about_dialog; /* actually child of toplevel */
				Widget author_item;
					Widget author_dialog; /* actually child of toplevel */
						Widget author_dialog_label1;
						Widget author_dialog_sep1;
						Widget author_dialog_pixmap;
						Widget author_dialog_sep2;
						Widget author_dialog_label2;
							Widget author_dialog_OK_button;
		Widget article_form;
			Widget article_header_form;
				Widget article_title_label;
				Widget article_summary_label;
				Widget article_reality_label;
				Widget article_author_label;
				Widget article_date_label;
				Widget article_reality_label;
				Widget article_title_label_actual;
				Widget article_summary_label_actual;
				Widget article_reality_label_actual;
				Widget article_author_label_actual;
				Widget article_date_label_actual;
				Widget article_reality_label_actual;
			Widget article_text;
			Widget article_xref_form;
				Widget article_xref_label;
				Widget article_xref_list;
		Widget titles_form;
			Widget titles_label;
			Widget titles_list;
			Widget titles_buttons_rowcol;
			Widget titles_index_button;
		Widget footer_form;
			Widget footer_label1;
			Widget footer_label2;

	Widget index_shell;
		Widget index_form;
			Widget index_label;
			Widget index_list;
			Widget index_hide_button;

/**********************Other**************************************/

/* Miscellaneous - for general use */
Arg al[20];
int ac;
XmString Xs;

/***FUNCTIONS****************************************************************/

void initialise_main_window()
{
	/* create the main form widget to hold all the other widgets */
	ac = 0;
    XtSetArg(al[ac], XmNleftOffset, 10); ac++;
    XtSetArg(al[ac], XmNrightOffset, 10); ac++;
    XtSetArg(al[ac], XmNtopOffset, 10); ac++;
    XtSetArg(al[ac], XmNbottomOffset, 10); ac++;
	main_form = XmCreateForm(toplevel, "MainForm", al, ac);
	XtManageChild(main_form);

/***Menu*********************************************************************/
        /* create the menu bar */
        ac = 0;
        main_menu_bar = XmCreateMenuBar(main_form, "MainMenuBar", al, ac);
        XtManageChild(main_menu_bar);

        /* attach the main_menu_bar to the main form */
        ac = 0;
        XtSetArg(al[ac], XmNtopAttachment, XmATTACH_FORM); ac++;
        XtSetArg(al[ac], XmNrightAttachment, XmATTACH_FORM); ac++;
        XtSetArg(al[ac], XmNleftAttachment, XmATTACH_FORM); ac++;
        XtSetValues(main_menu_bar, al, ac);

        /* add menus to the menu bar */
		/* file menu */
        file_menu = make_menu("File", main_menu_bar);
        load_item = make_menu_item("Create new Working Files", FILE_LOAD, file_menu);
        XtSetSensitive(load_item, True);
        save_item = make_menu_item("Save", FILE_SAVE, file_menu);
        XtSetSensitive(save_item, False);
        quit_item = make_menu_item("Quit", FILE_QUIT, file_menu);

		/* options menu */
        options_menu = make_menu("Options", main_menu_bar);
        reality_item = make_menu_item("Reality", OPTIONS_REALITY, options_menu);
        XtSetSensitive(reality_item, True);

		/* help menu */
		help_menu = make_help_menu("Help", main_menu_bar);
		about_item = make_menu_item("About...", HELP_ABOUT, help_menu);
		author_item = make_menu_item("Author...", HELP_AUTHOR, help_menu);
		XtSetSensitive(about_item, True);

/***Article Area*************************************************************/
	/* create form to hold the header information & text of articles */
	ac = 0;
    XtSetArg(al[ac], XmNleftOffset, 20); ac++;
    XtSetArg(al[ac], XmNrightOffset, 10); ac++;
    XtSetArg(al[ac], XmNtopOffset, 10); ac++;
    XtSetArg(al[ac], XmNbottomOffset, 10); ac++;
	XtSetArg(al[ac], XmNtopAttachment, XmATTACH_WIDGET); ac++;
	XtSetArg(al[ac], XmNtopWidget, main_menu_bar); ac++;
	XtSetArg(al[ac], XmNleftAttachment, XmATTACH_FORM); ac++;
	article_form = XmCreateForm(main_form, "ArticleForm", al, ac);
	XtManageChild(article_form);

	/* create form to hold the header information */
    ac = 0;
    XtSetArg(al[ac], XmNleftOffset, 10); ac++;
    XtSetArg(al[ac], XmNrightOffset, 10); ac++;
    XtSetArg(al[ac], XmNtopOffset, 10); ac++;
    XtSetArg(al[ac], XmNbottomOffset, 10); ac++;
    XtSetArg(al[ac], XmNtopAttachment, XmATTACH_FORM); ac++;
    XtSetArg(al[ac], XmNleftAttachment, XmATTACH_FORM); ac++;
    XtSetArg(al[ac], XmNrightAttachment, XmATTACH_FORM); ac++;
    article_header_form = XmCreateForm(article_form, "ArticleHeaderForm", al, ac);
	XtManageChild(article_header_form);
	/* create labels for header */
	ac = 0;
	XtSetArg(al[ac], XmNtopAttachment, XmATTACH_FORM); ac++;
	XtSetArg(al[ac], XmNleftAttachment, XmATTACH_FORM); ac++;
	XtSetArg(al[ac], XmNrightAttachment, XmATTACH_POSITION); ac++;
	XtSetArg(al[ac], XmNrightPosition, HEAD_OFFSET); ac++;
	XtSetArg(al[ac], XmNalignment, XmALIGNMENT_END); ac++;
	Xs = XmStringCreateLtoR("Title:", char_set);
	XtSetArg(al[ac], XmNlabelString, Xs); ac++;
	article_title_label = XmCreateLabel(article_header_form, "TitleLabel", al, ac);
	XtManageChild(article_title_label);
	XmStringFree(Xs);
	ac = 0;
	XtSetArg(al[ac], XmNtopAttachment, XmATTACH_WIDGET); ac++;
	XtSetArg(al[ac], XmNtopWidget, article_title_label); ac++;
	XtSetArg(al[ac], XmNleftAttachment, XmATTACH_FORM); ac++;
	XtSetArg(al[ac], XmNrightAttachment, XmATTACH_POSITION); ac++;
	XtSetArg(al[ac], XmNrightPosition, HEAD_OFFSET); ac++;
	XtSetArg(al[ac], XmNalignment, XmALIGNMENT_END); ac++;
	Xs = XmStringCreateLtoR("Summary:", char_set);
	XtSetArg(al[ac], XmNlabelString, Xs); ac++;
	article_summary_label = XmCreateLabel(article_header_form, "SummaryLabel", al, ac);
	XtManageChild(article_summary_label);
	XmStringFree(Xs);
	ac = 0;
	XtSetArg(al[ac], XmNtopAttachment, XmATTACH_WIDGET); ac++;
	XtSetArg(al[ac], XmNtopWidget, article_summary_label); ac++;
	XtSetArg(al[ac], XmNleftAttachment, XmATTACH_FORM); ac++;
	XtSetArg(al[ac], XmNrightAttachment, XmATTACH_POSITION); ac++;
	XtSetArg(al[ac], XmNrightPosition, HEAD_OFFSET); ac++;
	XtSetArg(al[ac], XmNalignment, XmALIGNMENT_END); ac++;
	Xs = XmStringCreateLtoR("Author:", char_set);
	XtSetArg(al[ac], XmNlabelString, Xs); ac++;
	article_author_label = XmCreateLabel(article_header_form, "AuthorLabel", al, ac);
	XtManageChild(article_author_label);
	XmStringFree(Xs);
	ac = 0;
	XtSetArg(al[ac], XmNtopAttachment, XmATTACH_WIDGET); ac++;
	XtSetArg(al[ac], XmNtopWidget, article_author_label); ac++;
	XtSetArg(al[ac], XmNleftAttachment, XmATTACH_FORM); ac++;
	XtSetArg(al[ac], XmNrightAttachment, XmATTACH_POSITION); ac++;
	XtSetArg(al[ac], XmNrightPosition, HEAD_OFFSET); ac++;
	XtSetArg(al[ac], XmNalignment, XmALIGNMENT_END); ac++;
	Xs = XmStringCreateLtoR("Date:", char_set);
	XtSetArg(al[ac], XmNlabelString, Xs); ac++;
	article_date_label = XmCreateLabel(article_header_form, "DateLabel", al, ac);
	XtManageChild(article_date_label);
	XmStringFree(Xs);
	ac = 0;
	XtSetArg(al[ac], XmNtopAttachment, XmATTACH_WIDGET); ac++;
	XtSetArg(al[ac], XmNtopWidget, article_date_label); ac++;
	XtSetArg(al[ac], XmNleftAttachment, XmATTACH_FORM); ac++;
	XtSetArg(al[ac], XmNrightAttachment, XmATTACH_POSITION); ac++;
	XtSetArg(al[ac], XmNrightPosition, HEAD_OFFSET); ac++;
	XtSetArg(al[ac], XmNalignment, XmALIGNMENT_END); ac++;
	Xs = XmStringCreateLtoR("Reality:", char_set);
	XtSetArg(al[ac], XmNlabelString, Xs); ac++;
	article_reality_label = XmCreateLabel(article_header_form, "RealityLabel", al, ac);
	XtManageChild(article_reality_label);
	XmStringFree(Xs);

	ac = 0;
	XtSetArg(al[ac], XmNtopAttachment, XmATTACH_FORM); ac++;
	XtSetArg(al[ac], XmNleftAttachment, XmATTACH_WIDGET); ac++;
	XtSetArg(al[ac], XmNleftWidget, article_title_label); ac++;
	XtSetArg(al[ac], XmNalignment, XmALIGNMENT_BEGINNING); ac++;
	article_title_label_actual = XmCreateLabel(article_header_form, "TitleLabelActual", al, ac);
	XtManageChild(article_title_label_actual);
	ac = 0;
	XtSetArg(al[ac], XmNtopAttachment, XmATTACH_WIDGET); ac++;
	XtSetArg(al[ac], XmNtopWidget, article_title_label_actual); ac++;
	XtSetArg(al[ac], XmNleftAttachment, XmATTACH_WIDGET); ac++;
	XtSetArg(al[ac], XmNleftWidget, article_summary_label); ac++;
	XtSetArg(al[ac], XmNalignment, XmALIGNMENT_BEGINNING); ac++;
	article_summary_label_actual = XmCreateLabel(article_header_form, "SummaryLabelActual", al, ac);
	XtManageChild(article_summary_label_actual);
	ac = 0;
	XtSetArg(al[ac], XmNtopAttachment, XmATTACH_WIDGET); ac++;
	XtSetArg(al[ac], XmNtopWidget, article_summary_label_actual); ac++;
	XtSetArg(al[ac], XmNleftAttachment, XmATTACH_WIDGET); ac++;
	XtSetArg(al[ac], XmNleftWidget, article_author_label); ac++;
	XtSetArg(al[ac], XmNalignment, XmALIGNMENT_BEGINNING); ac++;
	XtSetArg(al[ac], XmNrecomputeSize, True); ac++;
	article_author_label_actual = XmCreateLabel(article_header_form, "AuthorLabelActual", al, ac);
	XtManageChild(article_author_label_actual);
	ac = 0;
	XtSetArg(al[ac], XmNtopAttachment, XmATTACH_WIDGET); ac++;
	XtSetArg(al[ac], XmNtopWidget, article_author_label_actual); ac++;
	XtSetArg(al[ac], XmNleftAttachment, XmATTACH_WIDGET); ac++;
	XtSetArg(al[ac], XmNleftWidget, article_date_label); ac++;
	XtSetArg(al[ac], XmNalignment, XmALIGNMENT_BEGINNING); ac++;
	article_date_label_actual = XmCreateLabel(article_header_form, "DateLabelActual", al, ac);
	XtManageChild(article_date_label_actual);
	ac = 0;
	XtSetArg(al[ac], XmNtopAttachment, XmATTACH_WIDGET); ac++;
	XtSetArg(al[ac], XmNtopWidget, article_date_label_actual); ac++;
	XtSetArg(al[ac], XmNleftAttachment, XmATTACH_WIDGET); ac++;
	XtSetArg(al[ac], XmNleftWidget, article_reality_label); ac++;
	XtSetArg(al[ac], XmNalignment, XmALIGNMENT_BEGINNING); ac++;
	article_reality_label_actual = XmCreateLabel(article_header_form, "RealityLabelActual", al, ac);
	XtManageChild(article_reality_label_actual);

	/* create a scrolled text widget to display text of articles */
	ac = 0;
	XtSetArg(al[ac], XmNeditable, False); ac++;
	XtSetArg(al[ac], XmNeditMode, XmMULTI_LINE_EDIT); ac++;
	XtSetArg(al[ac], XmNcursorPositionVisible, False); ac++;
	XtSetArg(al[ac], XmNtopAttachment, XmATTACH_WIDGET); ac++;
	XtSetArg(al[ac], XmNtopWidget, article_header_form); ac++;
	XtSetArg(al[ac], XmNleftAttachment, XmATTACH_FORM); ac++;
	article_text = XmCreateScrolledText(article_form, "ArticleText", al, ac);
	XtManageChild(article_text);

	/* create form to hold the cross-reference information */
    ac = 0;
    XtSetArg(al[ac], XmNtopAttachment, XmATTACH_WIDGET); ac++;
    XtSetArg(al[ac], XmNtopWidget, article_text); ac++;
    XtSetArg(al[ac], XmNleftAttachment, XmATTACH_FORM); ac++;
    XtSetArg(al[ac], XmNrightAttachment, XmATTACH_OPPOSITE_WIDGET); ac++;
    XtSetArg(al[ac], XmNrightWidget, article_text); ac++;
    article_xref_form = XmCreateForm(article_form, "ArticleXrefForm", al, ac);
	XtManageChild(article_xref_form);
	
	/* label the xref area */
	ac = 0;
	XtSetArg(al[ac], XmNtopAttachment, XmATTACH_FORM); ac++;
	XtSetArg(al[ac], XmNleftAttachment, XmATTACH_FORM); ac++;
	XtSetArg(al[ac], XmNrightAttachment, XmATTACH_FORM); ac++;
	XtSetArg(al[ac], XmNalignment, XmALIGNMENT_BEGINNING); ac++;
	Xs = XmStringCreateLtoR("Cross-References", char_set);
	XtSetArg(al[ac], XmNlabelString, Xs); ac++;
	article_xref_label = XmCreateLabel(article_xref_form, "XrefLabel", al, ac);
	XtManageChild(article_xref_label);
	XmStringFree(Xs);

	/* create a list widget to select a cross-referenced article from */
	ac = 0;
	XtSetArg(al[ac], XmNselectionPolicy, XmSINGLE_SELECT); ac++;
	XtSetArg(al[ac], XmNlistSizePolicy, XmRESIZE_IF_POSSIBLE); ac++;
	XtSetArg(al[ac], XmNtopAttachment, XmATTACH_WIDGET); ac++;
	XtSetArg(al[ac], XmNtopWidget, article_xref_label); ac++;
	XtSetArg(al[ac], XmNbottomAttachment, XmATTACH_FORM); ac++;
	XtSetArg(al[ac], XmNleftAttachment, XmATTACH_FORM); ac++;
	XtSetArg(al[ac], XmNrightAttachment, XmATTACH_FORM); ac++;
	article_xref_list = XmCreateScrolledList(article_xref_form, "XrefList", al, ac);
	XtManageChild(article_xref_list);
	XtAddCallback(article_xref_list, XmNsingleSelectionCallback, xref_select_CB, NULL);

/***Title Selection Area*****************************************************/
	/* create form to hold the list of titles to chose from */
	/* note: will also be used if user wishes to consult the index rather
	than the titles */
	ac = 0;
    XtSetArg(al[ac], XmNleftOffset, 20); ac++;
    XtSetArg(al[ac], XmNrightOffset, 20); ac++;
    XtSetArg(al[ac], XmNtopOffset, 20); ac++;
    XtSetArg(al[ac], XmNbottomOffset, 20); ac++;
	XtSetArg(al[ac], XmNtopAttachment, XmATTACH_WIDGET); ac++;
	XtSetArg(al[ac], XmNtopWidget, main_menu_bar); ac++;
	XtSetArg(al[ac], XmNleftAttachment, XmATTACH_WIDGET); ac++;
	XtSetArg(al[ac], XmNleftWidget, article_form); ac++;
	XtSetArg(al[ac], XmNrightAttachment, XmATTACH_FORM); ac++;
	titles_form = XmCreateForm(main_form, "TitlesForm", al, ac);
	XtManageChild(titles_form);

	/* label the titles/index area */
	ac = 0;
	XtSetArg(al[ac], XmNtopAttachment, XmATTACH_FORM); ac++;
	XtSetArg(al[ac], XmNleftAttachment, XmATTACH_FORM); ac++;
	XtSetArg(al[ac], XmNrightAttachment, XmATTACH_FORM); ac++;
	XtSetArg(al[ac], XmNalignment, XmALIGNMENT_CENTER); ac++;
	Xs = XmStringCreateLtoR("Table of Contents", char_set);
	XtSetArg(al[ac], XmNlabelString, Xs); ac++;
	titles_label = XmCreateLabel(titles_form, "TitlesLabel", al, ac);
	XtManageChild(titles_label);
	XmStringFree(Xs);

	/* create a list widget to select title from */
	ac = 0;
	XtSetArg(al[ac], XmNselectionPolicy, XmSINGLE_SELECT); ac++;
	XtSetArg(al[ac], XmNlistSizePolicy, XmRESIZE_IF_POSSIBLE); ac++;
	XtSetArg(al[ac], XmNtopAttachment, XmATTACH_WIDGET); ac++;
	XtSetArg(al[ac], XmNtopWidget, titles_label); ac++;
	XtSetArg(al[ac], XmNleftAttachment, XmATTACH_FORM); ac++;
	titles_list = XmCreateScrolledList(titles_form, "TitlesList", al, ac);
	XtManageChild(titles_list);
	XtAddCallback(titles_list, XmNsingleSelectionCallback, titles_select_CB, NULL);

	/* create a rowcol to hold the buttons for 'Index', 'Find', etc */
	ac = 0;
    XtSetArg(al[ac], XmNpacking, XmPACK_COLUMN); ac++;
    XtSetArg(al[ac], XmNorientation, XmHORIZONTAL); ac++;
    XtSetArg(al[ac], XmNnumColumns, 1); ac++;
    XtSetArg(al[ac], XmNisAligned, False); ac++;
    XtSetArg(al[ac], XmNentryAlignment, XmALIGNMENT_CENTER); ac++;
    XtSetArg(al[ac], XmNadjustLast, False); ac++;
    XtSetArg(al[ac], XmNtopAttachment, XmATTACH_WIDGET); ac++;
    XtSetArg(al[ac], XmNtopWidget, titles_list); ac++;
    XtSetArg(al[ac], XmNleftAttachment, XmATTACH_FORM); ac++;
    XtSetArg(al[ac], XmNrightAttachment, XmATTACH_FORM); ac++;
    titles_buttons_rowcol = XmCreateRowColumn(titles_form,
		 "TitlesButtonsRowcol", al, ac);
    XtManageChild(titles_buttons_rowcol);

	/* add buttons to the rowcol */
	ac = 0;
	Xs = XmStringCreateLtoR("Show Index", char_set);
	XtSetArg(al[ac], XmNlabelString, Xs); ac++;
	titles_index_button = XmCreatePushButton(titles_buttons_rowcol,
		"TitlesIndexButton", al, ac);
	XtManageChild(titles_index_button);
	XmStringFree(Xs);
	XtAddCallback(titles_index_button, XmNactivateCallback, index_buttonCB, NULL);
	
/***Footer Area**************************************************************/

	/* create the footer form widget to hold status messages etc. */
	ac = 0;
	XtSetArg(al[ac], XmNleftOffset, 20); ac++;
	XtSetArg(al[ac], XmNrightOffset, 10); ac++;
	XtSetArg(al[ac], XmNtopOffset, 10); ac++;
	XtSetArg(al[ac], XmNbottomOffset, 20); ac++;
	XtSetArg(al[ac], XmNtopAttachment, XmATTACH_WIDGET); ac++;
	XtSetArg(al[ac], XmNtopWidget, article_form); ac++;
	XtSetArg(al[ac], XmNleftAttachment, XmATTACH_FORM); ac++;
	XtSetArg(al[ac], XmNrightAttachment, XmATTACH_OPPOSITE_WIDGET); ac++;
	XtSetArg(al[ac], XmNrightWidget, titles_form); ac++;
	XtSetArg(al[ac], XmNbottomAttachment, XmATTACH_FORM); ac++;
	footer_form = XmCreateForm(main_form, "FooterForm", al, ac);
	XtManageChild(footer_form);

	/* put a "default" label in the Footer area */
	ac = 0;
	XtSetArg(al[ac], XmNtopAttachment, XmATTACH_FORM); ac++;
	XtSetArg(al[ac], XmNleftAttachment, XmATTACH_FORM); ac++;
	XtSetArg(al[ac], XmNrightAttachment, XmATTACH_FORM); ac++;
	XtSetArg(al[ac], XmNalignment, XmALIGNMENT_CENTER); ac++;
	Xs = XmStringCreateLtoR("Xguide - An X Windows Article Viewer for", char_set);
	XtSetArg(al[ac], XmNlabelString, Xs); ac++;
	footer_label1 = XmCreateLabel(footer_form, "FooterLabel1", al, ac);
	XtManageChild(footer_label1);
	XmStringFree(Xs);
	ac = 0;
	XtSetArg(al[ac], XmNtopAttachment, XmATTACH_WIDGET); ac++;
	XtSetArg(al[ac], XmNtopWidget, footer_label1); ac++;
	XtSetArg(al[ac], XmNleftAttachment, XmATTACH_FORM); ac++;
	XtSetArg(al[ac], XmNrightAttachment, XmATTACH_FORM); ac++;
	XtSetArg(al[ac], XmNalignment, XmALIGNMENT_CENTER); ac++;
	Xs = XmStringCreateLtoR("          Don't Panic  -  Project Galactic Guide  -  Share and Enjoy", char_set);
	XtSetArg(al[ac], XmNlabelString, Xs); ac++;
	footer_label2 = XmCreateLabel(footer_form, "FooterLabel2", al, ac);
	XtManageChild(footer_label2);
	XmStringFree(Xs);

/***Dialog Boxes*************************************************************/

	/* create (but do NOT manage the "About..." information dialog */
	ac = 0;
	Xs = XmStringCreateLtoR(
	"Xguide - An X windows article viewer for Project Galactic Guide Articles\n\nVersion beta 1.11\nDate of Last Revision: 7 March 1994\n\nAuthor: David Squire\nPlease email comments, criticisms and suggestions to\n         squizz@cs.curtin.edu.au", char_set);
	XtSetArg(al[ac], XmNmessageString, Xs); ac++;
	about_dialog = XmCreateInformationDialog(toplevel, "AboutDialog", al, ac);
	XmStringFree(Xs);
	XtAddCallback(about_dialog, XmNokCallback, about_dialogCB, OK);
	XtAddCallback(about_dialog, XmNcancelCallback, about_dialogCB, CANCEL);
	XtUnmanageChild(XmMessageBoxGetChild(about_dialog, XmDIALOG_HELP_BUTTON));
	XtUnmanageChild(XmMessageBoxGetChild(about_dialog, XmDIALOG_CANCEL_BUTTON));

	/* create (but do NOT manage the "Reality" options dialog */
	ac = 0;
	XtSetArg(al[ac], XmNautoUnmanage, False); ac++;
	reality_dialog = XmCreateFormDialog(reality_item, "RealityDialog", al, ac);

	/* label the dialog box */
	ac = 0;
	Xs = XmStringCreateLtoR("Click to toggle the reality levels you\nwant to appear in the Table of Contents", char_set);
	XtSetArg(al[ac], XmNlabelString, Xs); ac++;
	XtSetArg(al[ac], XmNtopAttachment, XmATTACH_FORM); ac++;
	XtSetArg(al[ac], XmNleftAttachment, XmATTACH_FORM); ac++;
	XtSetArg(al[ac], XmNrightAttachment, XmATTACH_FORM); ac++;
	XtSetArg(al[ac], XmNtopOffset, 20); ac++;
	XtSetArg(al[ac], XmNbottomOffset, 20); ac++;
	XtSetArg(al[ac], XmNleftOffset, 20); ac++;
	XtSetArg(al[ac], XmNrightOffset, 20); ac++;
	reality_dialog_label1 = XmCreateLabel(reality_dialog, "RealityDialogLabel1", al, ac);
	XtManageChild(reality_dialog_label1);
	XmStringFree(Xs);

	/* add a nice separator */
	ac = 0;
	XtSetArg(al[ac], XmNorientation, XmHORIZONTAL); ac++;
	XtSetArg(al[ac], XmNseparatorType, XmSHADOW_ETCHED_IN); ac++;
	XtSetArg(al[ac], XmNtopAttachment, XmATTACH_WIDGET); ac++;
	XtSetArg(al[ac], XmNtopWidget, reality_dialog_label1); ac++;
	XtSetArg(al[ac], XmNleftAttachment, XmATTACH_FORM); ac++;
	XtSetArg(al[ac], XmNrightAttachment, XmATTACH_FORM); ac++;
	XtSetArg(al[ac], XmNtopOffset, 20); ac++;
	XtSetArg(al[ac], XmNbottomOffset, 20); ac++;
	reality_dialog_sep1 = XmCreateSeparator(reality_dialog, "RealityDialogSep", al, ac);
	XtManageChild(reality_dialog_sep1);

	/* create a rowcol to hold the toggle buttons */
	ac = 0;
    XtSetArg(al[ac], XmNorientation, XmVERTICAL); ac++;
    XtSetArg(al[ac], XmNnumColumns, 1); ac++;
    XtSetArg(al[ac], XmNisAligned, True); ac++;
    XtSetArg(al[ac], XmNentryAlignment, XmALIGNMENT_BEGINNING); ac++;
    XtSetArg(al[ac], XmNadjustLast, False); ac++;
	XtSetArg(al[ac], XmNtopAttachment, XmATTACH_WIDGET); ac++;
	XtSetArg(al[ac], XmNtopWidget, reality_dialog_sep1); ac++;
	XtSetArg(al[ac], XmNleftAttachment, XmATTACH_FORM); ac++;
	XtSetArg(al[ac], XmNrightAttachment, XmATTACH_FORM); ac++;
    XtSetArg(al[ac], XmNtopOffset, 20); ac++;
    XtSetArg(al[ac], XmNbottomOffset, 20); ac++;
    XtSetArg(al[ac], XmNleftOffset, 20); ac++;
    XtSetArg(al[ac], XmNrightOffset, 20); ac++;
	reality_toggle_rowcol = XmCreateRowColumn(reality_dialog, "RealityToggleRowcol", al, ac);	
	XtManageChild(reality_toggle_rowcol);
	/* create the toggle buttons & put them in the rowcol */
	ac = 0;
	Xs = XmStringCreateLtoR("Real", char_set);
	XtSetArg(al[ac], XmNlabelString, Xs); ac++;
	XtSetArg(al[ac], XmNset, True); ac++;
	display_real = True;
    XtSetArg(al[ac], XmNhighlightThickness, 0); ac++;
	reality_real_toggle = XmCreateToggleButton(reality_toggle_rowcol, "RealityToggle", al, ac);
	XtManageChild(reality_real_toggle);
	XmStringFree(Xs);
	ac = 0;
	Xs = XmStringCreateLtoR("Semi-Real", char_set);
	XtSetArg(al[ac], XmNlabelString, Xs); ac++;
	XtSetArg(al[ac], XmNset, True); ac++;
	display_semi_real = True;
    XtSetArg(al[ac], XmNhighlightThickness, 0); ac++;
	reality_semireal_toggle = XmCreateToggleButton(reality_toggle_rowcol, "RealityToggle", al, ac);
	XtManageChild(reality_semireal_toggle);
	XmStringFree(Xs);
	ac = 0;
	Xs = XmStringCreateLtoR("Unreal", char_set);
	XtSetArg(al[ac], XmNlabelString, Xs); ac++;
	XtSetArg(al[ac], XmNset, True); ac++;
	display_unreal = True;
    XtSetArg(al[ac], XmNhighlightThickness, 0); ac++;
	reality_unreal_toggle = XmCreateToggleButton(reality_toggle_rowcol, "RealityToggle", al, ac);
	XtManageChild(reality_unreal_toggle);
	XmStringFree(Xs);

	/* add a nice separator */
	ac = 0;
	XtSetArg(al[ac], XmNorientation, XmHORIZONTAL); ac++;
	XtSetArg(al[ac], XmNseparatorType, XmSHADOW_ETCHED_IN); ac++;
	XtSetArg(al[ac], XmNtopAttachment, XmATTACH_WIDGET); ac++;
	XtSetArg(al[ac], XmNtopWidget, reality_toggle_rowcol); ac++;
	XtSetArg(al[ac], XmNleftAttachment, XmATTACH_FORM); ac++;
	XtSetArg(al[ac], XmNrightAttachment, XmATTACH_FORM); ac++;
	XtSetArg(al[ac], XmNtopOffset, 20); ac++;
	XtSetArg(al[ac], XmNbottomOffset, 20); ac++;
	reality_dialog_sep2 = XmCreateSeparator(reality_dialog, "RealityDialogSep", al, ac);
	XtManageChild(reality_dialog_sep2);

	/* create a form to hold the OK & Cancel buttons */
	XtSetArg(al[ac], XmNtopAttachment, XmATTACH_WIDGET); ac++;
	XtSetArg(al[ac], XmNtopWidget, reality_dialog_sep2); ac++;
	XtSetArg(al[ac], XmNleftAttachment, XmATTACH_FORM); ac++;
	XtSetArg(al[ac], XmNrightAttachment, XmATTACH_FORM); ac++;
	XtSetArg(al[ac], XmNbottomAttachment, XmATTACH_FORM); ac++;
    XtSetArg(al[ac], XmNtopOffset, 20); ac++;
    XtSetArg(al[ac], XmNbottomOffset, 20); ac++;
    XtSetArg(al[ac], XmNleftOffset, 20); ac++;
    XtSetArg(al[ac], XmNrightOffset, 20); ac++;
	reality_button_form = XmCreateForm(reality_dialog, "RealityButtonRowcol", al, ac);	
	XtManageChild(reality_button_form);
	
	/* Now add the buttons */
	ac = 0;
	Xs = XmStringCreateLtoR("OK", char_set);
	XtSetArg(al[ac], XmNlabelString, Xs); ac++;
	XtSetArg(al[ac], XmNshowAsDefault, True); ac++;
	XtSetArg(al[ac], XmNtopAttachment, XmATTACH_FORM); ac++;
	XtSetArg(al[ac], XmNrightAttachment, XmATTACH_POSITION); ac++;
	XtSetArg(al[ac], XmNrightPosition, 40); ac++;
	XtSetArg(al[ac], XmNbottomAttachment, XmATTACH_FORM); ac++;
	reality_dialog_OK_button = XmCreatePushButton(reality_button_form, "RealityOKButton", al, ac);
	XmStringFree(Xs);
	XtManageChild(reality_dialog_OK_button);
	XtAddCallback(reality_dialog_OK_button, XmNactivateCallback, reality_dialogCB, OK);

	ac = 0;
	Xs = XmStringCreateLtoR("Cancel", char_set);
	XtSetArg(al[ac], XmNlabelString, Xs); ac++;
	XtSetArg(al[ac], XmNtopAttachment, XmATTACH_FORM); ac++;
	XtSetArg(al[ac], XmNleftAttachment, XmATTACH_POSITION); ac++;
	XtSetArg(al[ac], XmNleftPosition, 60); ac++;
	XtSetArg(al[ac], XmNbottomAttachment, XmATTACH_FORM); ac++;
	reality_dialog_CANCEL_button = XmCreatePushButton(reality_button_form, "RealityCancelButton", al, ac);
	XmStringFree(Xs);
	XtManageChild(reality_dialog_CANCEL_button);
	XtAddCallback(reality_dialog_CANCEL_button, XmNactivateCallback, reality_dialogCB, CANCEL);

	/* create (but do NOT manage the "Author" dialog */
	ac = 0;
	author_dialog = XmCreateFormDialog(toplevel, "AuthorDialog", al, ac);

	/* label the dialog box */
	ac = 0;
	Xs = XmStringCreateLtoR("Xguide was written by\nDavid McG. Squire\nsquizz@cs.curtin.edu.au", char_set);
	XtSetArg(al[ac], XmNlabelString, Xs); ac++;
	XtSetArg(al[ac], XmNtopAttachment, XmATTACH_FORM); ac++;
	XtSetArg(al[ac], XmNleftAttachment, XmATTACH_FORM); ac++;
	XtSetArg(al[ac], XmNrightAttachment, XmATTACH_FORM); ac++;
	XtSetArg(al[ac], XmNtopOffset, 20); ac++;
	XtSetArg(al[ac], XmNbottomOffset, 20); ac++;
	XtSetArg(al[ac], XmNleftOffset, 20); ac++;
	XtSetArg(al[ac], XmNrightOffset, 20); ac++;
	author_dialog_label1 = XmCreateLabel(author_dialog, "AuthorDialogLabel1", al, ac);
	XtManageChild(author_dialog_label1);
	XmStringFree(Xs);

	/* add a nice separator */
	ac = 0;
	XtSetArg(al[ac], XmNorientation, XmHORIZONTAL); ac++;
	XtSetArg(al[ac], XmNseparatorType, XmSHADOW_ETCHED_IN); ac++;
	XtSetArg(al[ac], XmNtopAttachment, XmATTACH_WIDGET); ac++;
	XtSetArg(al[ac], XmNtopWidget, author_dialog_label1); ac++;
	XtSetArg(al[ac], XmNleftAttachment, XmATTACH_FORM); ac++;
	XtSetArg(al[ac], XmNrightAttachment, XmATTACH_FORM); ac++;
	XtSetArg(al[ac], XmNtopOffset, 20); ac++;
	XtSetArg(al[ac], XmNbottomOffset, 20); ac++;
	author_dialog_sep1 = XmCreateSeparator(author_dialog, "AuthorDialogSep", al, ac);
	XtManageChild(author_dialog_sep1);

	/* add a label for author's picture */
	ac = 0;
	XtSetArg(al[ac], XmNlabelType, XmPIXMAP); ac++;
	XtSetArg(al[ac], XmNtopAttachment, XmATTACH_WIDGET); ac++;
	XtSetArg(al[ac], XmNtopWidget, author_dialog_sep1); ac++;
	XtSetArg(al[ac], XmNleftAttachment, XmATTACH_FORM); ac++;
	XtSetArg(al[ac], XmNrightAttachment, XmATTACH_FORM); ac++;
	XtSetArg(al[ac], XmNtopOffset, 20); ac++;
	XtSetArg(al[ac], XmNbottomOffset, 20); ac++;
	XtSetArg(al[ac], XmNleftOffset, 20); ac++;
	XtSetArg(al[ac], XmNrightOffset, 20); ac++;
	author_dialog_pixmap = XmCreateLabel(author_dialog, "AuthorDialogPixmap", al, ac);
	XtManageChild(author_dialog_pixmap);

	/* add a nice separator */
	ac = 0;
	XtSetArg(al[ac], XmNorientation, XmHORIZONTAL); ac++;
	XtSetArg(al[ac], XmNseparatorType, XmSHADOW_ETCHED_IN); ac++;
	XtSetArg(al[ac], XmNtopAttachment, XmATTACH_WIDGET); ac++;
	XtSetArg(al[ac], XmNtopWidget, author_dialog_pixmap); ac++;
	XtSetArg(al[ac], XmNleftAttachment, XmATTACH_FORM); ac++;
	XtSetArg(al[ac], XmNrightAttachment, XmATTACH_FORM); ac++;
	XtSetArg(al[ac], XmNtopOffset, 20); ac++;
	XtSetArg(al[ac], XmNbottomOffset, 20); ac++;
	author_dialog_sep2 = XmCreateSeparator(author_dialog, "AuthorDialogSep", al, ac);
	XtManageChild(author_dialog_sep2);

	/* Now for a nice quote */
	ac = 0;
	Xs = XmStringCreateLtoR("`Ego? What Ego?'", char_set);
	XtSetArg(al[ac], XmNlabelString, Xs); ac++;
	XtSetArg(al[ac], XmNtopAttachment, XmATTACH_WIDGET); ac++;
	XtSetArg(al[ac], XmNtopWidget, author_dialog_sep2); ac++;
	XtSetArg(al[ac], XmNleftAttachment, XmATTACH_FORM); ac++;
	XtSetArg(al[ac], XmNrightAttachment, XmATTACH_FORM); ac++;
	XtSetArg(al[ac], XmNtopOffset, 20); ac++;
	XtSetArg(al[ac], XmNbottomOffset, 20); ac++;
	XtSetArg(al[ac], XmNleftOffset, 20); ac++;
	XtSetArg(al[ac], XmNrightOffset, 20); ac++;
	author_dialog_label2 = XmCreateLabel(author_dialog, "AuthorDialogLabel2", al, ac);
	XtManageChild(author_dialog_label2);
	XmStringFree(Xs);

	/* Now add the buttons */
	ac = 0;
	Xs = XmStringCreateLtoR("OK! Enough! Put it away!", char_set);
	XtSetArg(al[ac], XmNlabelString, Xs); ac++;
	XtSetArg(al[ac], XmNshowAsDefault, True); ac++;
	XtSetArg(al[ac], XmNtopAttachment, XmATTACH_WIDGET); ac++;
	XtSetArg(al[ac], XmNtopWidget, author_dialog_label2); ac++;
	XtSetArg(al[ac], XmNleftAttachment, XmATTACH_FORM); ac++;
	XtSetArg(al[ac], XmNrightAttachment, XmATTACH_FORM); ac++;
	XtSetArg(al[ac], XmNbottomAttachment, XmATTACH_FORM); ac++;
	author_dialog_OK_button = XmCreatePushButton(author_dialog, "AuthorOKButton", al, ac);
	XmStringFree(Xs);
	XtManageChild(author_dialog_OK_button);

/***Index Shell**************************************************************/
/* create but do not realise this shell */

	/* create a new shell to hold the index, rather than a dialog box,
	since the user will want to be able to move it around, etc */
	ac = 0;
    XtSetArg(al[ac], XmNleftOffset, 10); ac++;
    XtSetArg(al[ac], XmNrightOffset, 10); ac++;
    XtSetArg(al[ac], XmNtopOffset, 10); ac++;
    XtSetArg(al[ac], XmNbottomOffset, 10); ac++;
	index_shell = XtAppCreateShell("Xguide Index", "XGuideIndex",
		applicationShellWidgetClass, XtDisplay(toplevel), al, ac);

    /* create the main form widget to hold all the other widgets */
    ac = 0;
    XtSetArg(al[ac], XmNleftOffset, 10); ac++;
    XtSetArg(al[ac], XmNrightOffset, 10); ac++;
    XtSetArg(al[ac], XmNtopOffset, 10); ac++;
    XtSetArg(al[ac], XmNbottomOffset, 10); ac++;
    index_form = XmCreateForm(index_shell, "IndexForm", al, ac);
    XtManageChild(index_form);

	/* label it */
	    ac = 0;
    XtSetArg(al[ac], XmNtopAttachment, XmATTACH_FORM); ac++;
    XtSetArg(al[ac], XmNleftAttachment, XmATTACH_FORM); ac++;
    XtSetArg(al[ac], XmNrightAttachment, XmATTACH_FORM); ac++;
    XtSetArg(al[ac], XmNalignment, XmALIGNMENT_CENTER); ac++;
    Xs = XmStringCreateLtoR("Index", char_set);
    XtSetArg(al[ac], XmNlabelString, Xs); ac++;
	XtSetArg(al[ac], XmNtopOffset, 20); ac++;
	XtSetArg(al[ac], XmNbottomOffset, 20); ac++;
	XtSetArg(al[ac], XmNleftOffset, 20); ac++;
	XtSetArg(al[ac], XmNrightOffset, 20); ac++;
    index_label = XmCreateLabel(index_form, "IndexLabel", al, ac);
    XtManageChild(index_label);
    XmStringFree(Xs);

	/* create a list widget to select index entry from */
	ac = 0;
	XtSetArg(al[ac], XmNselectionPolicy, XmSINGLE_SELECT); ac++;
	XtSetArg(al[ac], XmNlistSizePolicy, XmRESIZE_IF_POSSIBLE); ac++;
	XtSetArg(al[ac], XmNtopAttachment, XmATTACH_WIDGET); ac++;
	XtSetArg(al[ac], XmNtopWidget, index_label); ac++;
	XtSetArg(al[ac], XmNleftAttachment, XmATTACH_FORM); ac++;
	XtSetArg(al[ac], XmNrightAttachment, XmATTACH_FORM); ac++;
	XtSetArg(al[ac], XmNtopOffset, 20); ac++;
	XtSetArg(al[ac], XmNbottomOffset, 20); ac++;
	XtSetArg(al[ac], XmNleftOffset, 20); ac++;
	XtSetArg(al[ac], XmNrightOffset, 20); ac++;
	index_list = XmCreateScrolledList(index_form, "IndexList", al, ac);
	XtManageChild(index_list);
	XtAddCallback(index_list, XmNsingleSelectionCallback, index_selectCB, NULL);

	/* Now add the buttons */
	ac = 0;
	Xs = XmStringCreateLtoR("Hide Index", char_set);
	XtSetArg(al[ac], XmNlabelString, Xs); ac++;
	XtSetArg(al[ac], XmNshowAsDefault, True); ac++;
	XtSetArg(al[ac], XmNtopAttachment, XmATTACH_WIDGET); ac++;
	XtSetArg(al[ac], XmNtopWidget, index_list); ac++;
	XtSetArg(al[ac], XmNleftAttachment, XmATTACH_FORM); ac++;
	XtSetArg(al[ac], XmNrightAttachment, XmATTACH_FORM); ac++;
	XtSetArg(al[ac], XmNbottomAttachment, XmATTACH_FORM); ac++;
	XtSetArg(al[ac], XmNtopOffset, 20); ac++;
	XtSetArg(al[ac], XmNbottomOffset, 20); ac++;
	XtSetArg(al[ac], XmNleftOffset, 20); ac++;
	XtSetArg(al[ac], XmNrightOffset, 20); ac++;
	index_hide_button = XmCreatePushButton(index_form, "IndexHideButton", al, ac);
	XmStringFree(Xs);
	XtManageChild(index_hide_button);
	XtAddCallback(index_hide_button, XmNactivateCallback, index_hide_buttonCB, NULL);
}

/***The actual main() function for the whole thing******************************/

void main(argc, argv)
	int argc;
	char *argv[];
{
	/* create the toplevel shell */
	toplevel = XtAppInitialize(&context, "XGuide", NULL, 0, &argc, argv, NULL, NULL, 0);

	/* initialisation of windows */
	initialise_main_window();

	/* load information from working files */
	entries = load_working_files("CGUIDE", &total_entries);
	if (entries != NULL) {
		entries_file = fopen("CGUIDE.ENT", "r");
		/* initialise Widgets */
		add_titles_to_list(titles_list, entries, total_entries);
		add_index_entries_to_list(index_list, index_entries, total_index_entries);
		load_article(entries[toc[0]]);
	}

	/* Actually handle everything! */
	XtRealiseWidget(toplevel);
	XtAppMainLoop(context);

}
