/******************************************************************
**                                                               **
**        Author: David Squire          Created: 17/12/93        **
**                                                               **
**        Comments:No where near operational yet!                **
**                                                               **
**        Modifications:                                         **
**                                                               **
******************************************************************/

#include "Cguide.h"
#include "Cguide_X.h"
#include "Cguide_Xglobals.h"
#include "Cguide_std.proto"
#include "Cguide_X.proto" /* must be last!! */

/*********************Functions***********************************/

/* Callback functions */
XtCallbackProc menuCB(Widget w, enum menu_item client_data, XmAnyCallbackStruct *call_data)
	/* call back used for menu bar */
{
	switch(client_data) {
	case FILE_LOAD:
		update_working_files();
		destroy_entries(entries, total_entries);
		XmListDeleteAllItems(titles_list);
		XmListDeleteAllItems(index_list);
		total_entries = 0;
		entries = load_working_files("CGUIDE", &total_entries);
		entries_file = fopen("CGUIDE.ENT", "r");
		add_titles_to_list(titles_list, entries, total_entries);
		add_index_entries_to_list(index_list, index_entries, total_index_entries);
		load_article(entries[toc[0]]);
		break;
	case FILE_QUIT:
		exit(0);
		/*
		XtManageChild(main_quit_confirm);
		*/
		break;
	case OPTIONS_REALITY:
		/* set toggles to actual vaules of variables. This is
		   because the last call may have resulted in a 'Cancel'
		   rather than an 'OK' */
		ac = 0;
		XtSetArg(al[ac], XmNset, display_real); ac++;
		XtSetValues(reality_real_toggle, al, ac);
		ac = 0;
		XtSetArg(al[ac], XmNset, display_semi_real); ac++;
		XtSetValues(reality_semireal_toggle, al, ac);
		ac = 0;
		XtSetArg(al[ac], XmNset, display_unreal); ac++;
		XtSetValues(reality_unreal_toggle, al, ac);
		XtManageChild(reality_dialog);
		break;
	case HELP_ABOUT:
		XtManageChild(about_dialog);
		break;
	case HELP_AUTHOR:
		if (!squizz_pixmap_created)
			create_squizz_pixmap(XtWindow(toplevel), XtDisplay(toplevel));
		XtManageChild(author_dialog);
		break;
	default:
		break;
	}
}

XtCallbackProc quit_CB(w, client_data, call_data)
	 Widget w;
	 enum dialog_token client_data;
	 XmSelectionBoxCallbackStruct *call_data;
{
	switch(client_data) {
		case OK:
			exit(0);
			break;
		case CANCEL:
			break;
		default:
			break;
	}
	XtUnmanageChild(w);
}

XtCallbackProc titles_select_CB(Widget w, XtPointer client_data, XmListCallbackStruct call_data)
{
	int *pos_list;
	int pos_list_length;
	int mem_allocated; /* flag */

	mem_allocated = XmListGetSelectedPos(w, &pos_list, &pos_list_length);
	if (mem_allocated) {
		load_article(entries[toc[*pos_list - 1]]);
		free(pos_list);
	}
}

XtCallbackProc xref_select_CB(Widget w, XtPointer client_data, XmListCallbackStruct call_data)
{
	int *pos_list;
	int pos_list_length;
	int mem_allocated; /* flag */
	GUIDE_ENTRY *entry;
	char *title_selected = NULL;
	XmStringTable list_entries;
	int num_list_entries;

	mem_allocated = XmListGetSelectedPos(w, &pos_list, &pos_list_length);
	if (mem_allocated) {
		ac = 0;
		XtSetArg(al[ac], XmNitems, &list_entries); ac++;
		XtSetArg(al[ac], XmNitemCount, &num_list_entries); ac++;
		XtGetValues(w, al, ac);
		/* Note that for some STUPID reason, XmListGetSelectedPos() returns
		   positions starting with number 1, but when you actually get the
		   items, they are in a normal array starting with element 0. This
		   is why it is "*pos_list - 1" rather than just "*pos_list" below */
		XmStringGetLtoR(list_entries[*pos_list - 1], char_set, &title_selected);
		if ((entry = find_article(title_selected)) != NULL) {
			load_article(entry);
		}
		free(pos_list);
	}
}

XtCallbackProc about_dialogCB(w, client_data, call_data)
	 Widget w;
	 enum dialog_token client_data;
	 XmAnyCallbackStruct *call_data;
{
	switch(client_data) {
		case OK:
			break;
		case CANCEL:
			break;
		default:
			break;
	}
	XtUnmanageChild(w);
}

XtCallbackProc reality_dialogCB(w, client_data, call_data)
	 Widget w;
	 enum dialog_token client_data;
	 XmAnyCallbackStruct *call_data;
{
	Boolean set;

	switch(client_data) {
		case OK:
			ac = 0;
			/* extract values from toggles */
			XtSetArg(al[ac], XmNset, &set); ac++;
			XtGetValues(reality_real_toggle, al, ac);
			display_real = set;
			ac = 0;
			XtSetArg(al[ac], XmNset, &set); ac++;
			XtGetValues(reality_semireal_toggle, al, ac);
			display_semi_real = set;
			ac = 0;
			XtSetArg(al[ac], XmNset, &set); ac++;
			XtGetValues(reality_unreal_toggle, al, ac);
			display_unreal = set;
            XmListDeleteAllItems(titles_list);
            add_titles_to_list(titles_list, entries, total_entries);
            load_article(entries[toc[0]]);
			break;
		case CANCEL:
			break;
		default:
			break;
	}
	XtUnmanageChild(reality_dialog);
}

XtCallbackProc index_buttonCB(w, client_data, call_data)
	 Widget w;
	 caddr_t client_data;
	 XmAnyCallbackStruct *call_data;
{
	/* make the index button insensitive since only want one index shell ever */
	XtSetSensitive(titles_index_button, False);

	/* realise the shell */
	XtRealiseWidget(index_shell);
}

XtCallbackProc index_hide_buttonCB(w, client_data, call_data)
	 Widget w;
	 caddr_t client_data;
	 XmAnyCallbackStruct *call_data;
{
	/* unrealise the shell */
	XtUnrealiseWidget(index_shell);

	/* make the index button sensitive again */
	XtSetSensitive(titles_index_button, True);
}

XtCallbackProc index_selectCB(Widget w, XtPointer client_data, XmListCallbackStruct call_data)
{
	int *pos_list;
	int pos_list_length;
	int mem_allocated; /* flag */

	GUIDE_ENTRY *entry;

	mem_allocated = XmListGetSelectedPos(w, &pos_list, &pos_list_length);
	if (mem_allocated) {
		if ((entry = find_article(index_entries[*pos_list - 1].title)) != NULL)
			load_article(entry);
		free(pos_list);
	}
}
