/******************************************************************
**                                                               **
**        Author: David Squire          Created: 17/12/93        **
**                                                               **
**        Comments:No where near operational yet!                **
**                                                               **
**        Modifications:                                         **
**                                                               **
******************************************************************/

/* order matters here! */
#include "Cguide.h"
#include "Cguide_X.h"
#include "Cguide_Xglobals.h" /* must be after other .h files */
#include "Cguide_std.proto"
#include "Cguide_X.proto" /* must be last!! */

#include "bitmaps.h"
static Pixmap squizz;

/* Initialisation Functions */

Widget make_menu_item(item_name, client_data, menu)
	char *item_name;
	int client_data;
	Widget menu;
/* adds an item into a menu */
{
	int ac;
	Arg al[10];
	Widget item;

	ac = 0;
	XtSetArg(al[ac], XmNlabelString, XmStringCreateLtoR(item_name, char_set)); ac++;
	item = XmCreatePushButton(menu, item_name, al, ac);
	XtManageChild(item);
	XtAddCallback(item, XmNactivateCallback, menuCB, (XtPointer)client_data);
	XtSetSensitive(item, True);
	return(item);
}

void make_menu_label(item_name, menu)
	char *item_name;
	Widget menu;

	/* adds a label into the menu. */
{
	int ac;
	Arg al[10];

	ac = 0;
	XtSetArg(al[ac], XmNlabelString, XmStringCreateLtoR(item_name, XmSTRING_DEFAULT_CHARSET)); ac++;
	XtManageChild(XmCreateLabel(menu, item_name, al, ac));
}

void make_menu_separator(menu)
	Widget menu;

	/* adds a separator into the menu */
{
	/* I have no idea why the compiler wants a typecast here */
	XtManageChild((Widget)XmCreateSeparator(menu, "sep", NULL, 0));
}

Widget make_menu(menu_name, menu_bar)
	char *menu_name;
	Widget menu_bar;
	/* creates a menu on the menu bar */
{
	int ac;
	Arg al[10];
	Widget menu, cascade;

	menu = XmCreatePulldownMenu(menu_bar, menu_name, NULL, 0);
	ac = 0;
	XtSetArg(al[ac], XmNsubMenuId, menu); ac++;
	XtSetArg(al[ac], XmNlabelString, XmStringCreateLtoR(menu_name, char_set)); ac++;
	cascade = XmCreateCascadeButton(menu_bar, menu_name, al, ac);
	XtManageChild(cascade);
	return(menu);
}

Widget make_help_menu(menu_name, menu_bar)
	char *menu_name;
	Widget menu_bar;
	/* creates a menu on the menu bar */
{
	int ac;
	Arg al[10];
	Widget menu, cascade;

	menu = XmCreatePulldownMenu(menu_bar, menu_name, NULL, 0);
	ac = 0;
	XtSetArg(al[ac], XmNsubMenuId, menu); ac++;
	XtSetArg(al[ac], XmNlabelString, XmStringCreateLtoR(menu_name, char_set)); ac++;
	cascade = XmCreateCascadeButton(menu_bar, menu_name, al, ac);
	XtManageChild(cascade);

	/* Wire the help menu into the rowcol widget's help menu resource. */
	ac = 0;
	XtSetArg(al[ac], XmNmenuHelpWidget, cascade); ac++;
	XtSetValues(menu_bar, al, ac);

	return(menu);
}

void watch_cursor(Widget w)
{
	Cursor c1;

	c1 = XCreateFontCursor(XtDisplay(w), XC_watch);
	XDefineCursor(XtDisplay(w), XtWindow(w), c1);
	XFlush(XtDisplay(w));
}

void normal_cursor(Widget w)
{
	XUndefineCursor(XtDisplay(w), XtWindow(w));
	XFlush(XtDisplay(w));
}

void add_titles_to_list(Widget titles_list, GUIDE_ENTRY **entries, int num_entries)
{
	XmString s;
	int i, j;
	int include;

	j = 0;
	for (i = 0; i < num_entries; i++) {
		include = False;
		switch(entries[i]->id[CODE_LENGTH]) {
        	case 'R':
				include = display_real;
            	break;
        	case 'S':
				include = display_semi_real;
            	break;
        	case 'U':
				include = display_unreal;
            	break;
        	default:
        	    break;
    	}
		if (include) {
			toc[j++] = i;
			s = XmStringCreate(entries[i]->title, char_set);
			XmListAddItem(titles_list, s, 0);
			XmStringFree(s);
		}
	}
}

void add_index_entries_to_list(Widget index_list, INDEX *index_entries, int num_entries)
{
	XmString s;
	int i;

	for (i = 0; i < num_entries; i++) {
		s = XmStringCreate(index_entries[i].index_entry, char_set);
		XmListAddItem(index_list, s, 0);
		XmStringFree(s);
	}
}
void load_article(GUIDE_ENTRY *entry)
{
	XmString Xs;
	char *s;

	if (entry->article == NULL)
		read_article(entries_file, entry->text_start, &entry->article, entry->article_length);

	/* put article text into text widget */
	XmTextSetString(article_text, entry->article);

	/* place details in header */
	ac = 0;
	Xs = XmStringCreateLtoR(entry->title, char_set);
	XtSetArg(al[ac], XmNlabelString, Xs); ac++;
	XtSetValues(article_title_label_actual, al, ac);
	XmStringFree(Xs);
	ac = 0;
	Xs = XmStringCreateLtoR(entry->summary, char_set);
	XtSetArg(al[ac], XmNlabelString, Xs); ac++;
	XtSetValues(article_summary_label_actual, al, ac);
	XmStringFree(Xs);
	ac = 0;
	Xs = XmStringCreateLtoR(entry->author, char_set);
	XtSetArg(al[ac], XmNlabelString, Xs); ac++;
	XtSetValues(article_author_label_actual, al, ac);
	XmStringFree(Xs);
	ac = 0;
	s = extract_date(entry->date);
	Xs = XmStringCreateLtoR(s, char_set);
	XtFree(s);
	XtSetArg(al[ac], XmNlabelString, Xs); ac++;
	XtSetValues(article_date_label_actual, al, ac);
	XmStringFree(Xs);
	ac = 0;
	Xs = XmStringCreateLtoR(extract_reality(entry->id), char_set);
	XtSetArg(al[ac], XmNlabelString, Xs); ac++;
	XtSetValues(article_reality_label_actual, al, ac);
	XmStringFree(Xs);
	
	/* set up the xrefs list */
	add_xrefs_to_list(article_xref_list, entry);
}

void add_xrefs_to_list(Widget xrefs_list, GUIDE_ENTRY *entry)
{
    XmString s;
    XREF *current, *top;

    XmListDeleteAllItems(xrefs_list);
    top = entry->first_xref;
    if (top == NULL)
        return;
    current = top;
    do {
        s = XmStringCreate(current->xtitle, char_set);
        XmListAddItem(xrefs_list, s, 0);
        XmStringFree(s);
        current = current->next;
    } while (current != NULL);
}

create_squizz_pixmap( Window win, Display *disp)
{
    int screen;
    Pixel fg, bg;
    unsigned int depth;

    /* extract window, display and screen */
    screen = DefaultScreen(disp);
    ac = 0;
    XtSetArg(al[ac], XmNforeground, &fg); ac++;
    XtSetArg(al[ac], XmNbackground, &bg); ac++;
    XtSetArg(al[ac], XmNdepth, &depth); ac++;
    XtGetValues(author_dialog_pixmap, al, ac);

	squizz = XCreatePixmapFromBitmapData(disp, win, squizz_bits, squizz_width, squizz_height, fg, bg, depth);
	squizz_pixmap_created = True;
	ac = 0;
	XtSetArg(al[ac], XmNlabelPixmap, squizz); ac++;
	XtSetValues(author_dialog_pixmap, al, ac);
}
