#include "Cguide.h"
#include "Cguide_globals.h"
#include "Cguide_std.proto"

char *extract_date(long date)
{
	int year, month, day;
	char *s;

	s = (char *)malloc(LINE_LENGTH*sizeof(char));
	day = date % 100;
	date /= 100;
	month = date % 100;
	date /= 100;
	year = date;
	if ((year < 1980) || (month < 1) || (month > 12) || (day < 1) || (day >
	31))
		return("Corrupt Date Code");
	else {
		sprintf(s, "%d %s, %d", day, months[month], year);
		return(s);
	}
}

char *extract_reality(char id[])
{
	switch(id[CODE_LENGTH]) {
		case 'R':
			return("Real");
			break;
		case 'S':
			return("Semi-Real");
			break;
		case 'U':
			return("Un-Real");
			break;
		default:
			break;
	}
	return("Unknown!");
}

GUIDE_ENTRY *find_article(char *title)
/* Returns a pointer to an article with a title that matches 'title' */
/* Must be an exact match at the moment */
{
	GUIDE_ENTRY *dummy_entry;
	GUIDE_ENTRY **found_entry;

	if (title == NULL) {
		printf("NULL title passed to find_article!!\n");
		return(NULL);
	}
	dummy_entry = create_new_entry();
	strcpy(dummy_entry->title, title);
	found_entry = bsearch(&dummy_entry, entries, total_entries, sizeof(*entries), title_cmp);
	free(dummy_entry);
	if (found_entry == NULL)
		return(NULL);
	else
		return(*found_entry);
}

void destroy_entries(GUIDE_ENTRY **entries, int total_entries)
{
	int i;
	XREF *current_xref, *next_xref;
	INDEX *current_index, *next_index;

	for (i = 0; i < total_entries; i++) {
	/* There should not be any null entries, but check anyway ! */
		if (entries[i]->article != NULL)
			free(entries[i]->article);
		else
			printf("NULL article detected during destroy !!!\n");
		if (entries[i]->first_xref != NULL) {
			current_xref = entries[i]->first_xref;
			while (current_xref != NULL) {
				next_xref = current_xref->next;
				free(current_xref);
				current_xref = next_xref;
			}
		}
		if (entries[i]->first_index != NULL) {
			current_index = entries[i]->first_index;
			while (current_index != NULL) {
				next_index = current_index->next;
				free(current_index);
				current_index = next_index;
			}
		}
		free(entries[i]);
	}
	free(entries);
}

void update_toc()
{
}
