#include "Cguide.h"

char **get_filenames(int *n)
{
	char dirfname[L_tmpnam];
	char syscall[L_tmpnam + 15];
	FILE *dirfile;
	int num_inputfiles;
	char temp_fname[FNAME_LENGTH];
	char **fname_array;
	int i, j;
	
	tmpnam(dirfname);
	sprintf(syscall, "ls *.new > %s\n", dirfname);
	system(syscall);
	sprintf(syscall, "ls *.NEW >> %s\n", dirfname);
	system(syscall);
	dirfile = fopen(dirfname, "r");
	/* count input files */
	num_inputfiles = 0;
	while (fscanf(dirfile, "%s\n", temp_fname) == 1)
		num_inputfiles++;
	/* create an array containing the filenames */
	fname_array = (char **)malloc(num_inputfiles*sizeof(char *));
	/* read file names into array */
	rewind(dirfile);
	for (i = 0; i < num_inputfiles; i++) {
		fscanf(dirfile, "%s", temp_fname);
		fname_array[i] = (char *)malloc((strlen(temp_fname)+1)*sizeof(char));
		strcpy(fname_array[i], temp_fname);
	}
	*n = num_inputfiles;
	return(fname_array);
}

/**************************************************************************
**                                                                       **
**  read_article: This is in the 'unix' file because it strips the ^M    **
**                characters from the *.NEW files as they are read.      **
**                                                                       **
**************************************************************************/

void read_article(FILE *ifile, long start_text, char **article, int
num_chars)
{
    int i;
    char c;

    *article = (char *)malloc(num_chars*sizeof(char));
    fseek(ifile, start_text, SEEK_SET);
    for (i = 0; i < num_chars - 1; )
		if ((c = getc(ifile)) != '\r')
       		(*article)[i++] = c;
    (*article)[i] = '\0';
	if (i != num_chars - 1)
		printf("Warning!\n");
}

/**************************************************************************
**                                                                       **
**  extract_text: This is in the 'unix' file because it doesn't count    **
**                the ^M characters from the *.NEW files.                **
**                                                                       **
**************************************************************************/
int extract_text(FILE *ifile, char **article)
{
    char c;
    long start_text;
	long temp;
    int found_end = FALSE;
    long num_chars = 0;
    int i;

    /* find the end of the line with %e on it */
    while ((c = getc(ifile)) != '\n')
        ;

    /* remember where the text starts */
    start_text = ftell(ifile);

    /* count characters in article */
    while (!found_end) {
        while ((c = getc(ifile)) != '\n')
			if (c != '\r')
            	num_chars++;
		num_chars++; /* count the '\n' */
		temp = ftell(ifile);
        if ((c = getc(ifile)) == '%') {
            if ((c = getc(ifile)) == DELIMIT_CHAR) {
                found_end = TRUE;
			}
            else {
				if (c != '\r')
                	num_chars += 2; /* count the '%' & what was next */
				else
					num_chars++; /* just count the '%' */
			}
        }
		else
			if (c != '\r')
				num_chars++; /* count whatever wasn't a '%' */
    }
	num_chars++; /* make space for the \0 */
    read_article(ifile, start_text, article, num_chars);
	/*
	fseek(ifile, temp, SEEK_SET);
	*/
    return(num_chars);
}

