/* Unix include files */
#include <stdio.h>
#include <math.h>
#include <string.h>

/* X include files */
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xatom.h>
#include <X11/Intrinsic.h>
#include <X11/Protocols.h>
#include <X11/Core.h>
#include <X11/StringDefs.h>
#include <X11/cursorfont.h>

/* Motif include files */
#include <Xm/Xm.h>
#include <Xm/ArrowB.h>
#include <Xm/CascadeB.h>
#include <Xm/DrawingA.h>
#include <Xm/FileSB.h>
#include <Xm/Form.h>
#include <Xm/Frame.h>
#include <Xm/Label.h>
#include <Xm/MessageB.h>
#include <Xm/PushB.h>
#include <Xm/RowColumn.h>
#include <Xm/ScrollBar.h>
#include <Xm/Separator.h>
#include <Xm/Text.h>
#include <Xm/ToggleB.h>

/* pixmaps */
#include "/usr/include/X11/bitmaps/gray3"
#include "/usr/include/X11/bitmaps/gray1"

/***** defines for motif GUI stuff *****/

/* Defence against American spelling!!! */
#define XtRealiseWidget XtRealizeWidget
#define XtUnrealiseWidget XtUnrealizeWidget
#define XtIsRealised XtIsRealized

/* Some standard definitions */
#define TRUE 1
#define FALSE 0
#define PI 3.1415927

/***** Stuff specific to PGG *****/

/* constants */
#define LINE_LENGTH 80
#define CODE_LENGTH 3
#define ID_LENGTH 2*CODE_LENGTH+2 /* 2 codes, 1 char for reality, 1 for \0 */
#define TITLE_CHAR 't'
#define SUMMARY_CHAR 's'
#define AUTHOR_CHAR 'a'
#define DATE_CHAR 'd'
#define FICTION_CHAR 'f'
#define NUMBER_CHAR 'n'
#define XREF_CHAR 'x'
#define INDEX_CHAR 'i'
#define DELIMIT_CHAR 'e'


/* types */
typedef struct XREF_dummy *XREF_ptr;

typedef struct XREF_dummy {
	char xtitle[LINE_LENGTH];	
	XREF_ptr next;
} XREF;

typedef struct INDEX_dummy *INDEX_ptr;

typedef struct INDEX_dummy {
	char index_entry[LINE_LENGTH];
	INDEX_ptr next;
} INDEX;
	
typedef struct GUIDE_ENTRY_dummy {
    char title[LINE_LENGTH];
    char id[ID_LENGTH];
    char summary[LINE_LENGTH];
    char author[LINE_LENGTH];
    long int date;
    XREF *first_xref;
    INDEX *first_index;
    char *article;
} GUIDE_ENTRY;


